#include "AudioAmp2_demo_objects.h"
#include "demo_types.h"

extern uint8_t demoFlag;
extern uint8_t demoMute;
extern uint8_t demoStandby;

void systemInit()
{
    mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_INT_PIN, _GPIO_INPUT );
    mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_AN_PIN, _GPIO_OUTPUT );
    mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_RST_PIN, _GPIO_OUTPUT );
    mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_CS_PIN, _GPIO_OUTPUT );
    mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_PWM_PIN, _GPIO_OUTPUT );
    mikrobus_logInit( _MIKROBUS2, 9600 );
    mikrobus_logWrite( "Initializing...", _LOG_LINE );
    Delay_ms( 100 );
}

void applicationInit()
{
    audioamp2_gpioDriverInit( (T_AUDIOAMP2_P)&_MIKROBUS1_GPIO );
    audioamp2_setGain( _AUDIOAMP2_20DB_GAIN );
    audioamp2_setMode( _AUDIOAMP2_PLAY_MODE );
    demoFlag = 0;
    demoMute = 2;
    demoStandby = 0;
    mikrobus_logWrite( "AudioAmp 2 is initialized", _LOG_LINE );
    Delay_ms( 200 );
}

void applicationTask()
{
// MUTE / UNMUTE
    if(demoMute == 1)
    {
        audioamp2_setMode( _AUDIOAMP2_MUTE_MODE );
    }
    else if(demoMute == 2)
    {
        audioamp2_setMode( _AUDIOAMP2_PLAY_MODE );
    }
// GAIN
    if(demoFlag == 1)
    {
        demoStandby = 0;
        audioamp2_setGain( _AUDIOAMP2_20DB_GAIN );
        audioamp2_setMode( _AUDIOAMP2_PLAY_MODE );
        demoFlag = 0;
    }
    else if(demoFlag == 2)
    {   
        demoStandby = 0;
        audioamp2_setGain( _AUDIOAMP2_26DB_GAIN );
        audioamp2_setMode( _AUDIOAMP2_PLAY_MODE );
        demoFlag = 0;
    }
    else if(demoFlag == 3)
    {
        demoStandby = 0;
        audioamp2_setGain( _AUDIOAMP2_30DB_GAIN );
        audioamp2_setMode( _AUDIOAMP2_PLAY_MODE );
        demoFlag = 0;
    }
    else if (demoFlag == 4)
    {
        demoStandby = 0;
        audioamp2_setGain( _AUDIOAMP2_32DB_GAIN );
        audioamp2_setMode( _AUDIOAMP2_PLAY_MODE );
        demoFlag = 0;
    }
// STANDBY
    if(demoStandby == 1)
    {
        audioamp2_setMode( _AUDIOAMP2_STANDBY_MODE );
    }
}

void main()
{
    Start_TP();
    systemInit();
    applicationInit();

    while (1)
    {
        Check_TP();
        applicationTask();
    }
}