#line 1 "C:/Users/katarina.perendic/Downloads/AudioAmp2_demo/AudioAmp2_demo_main.c"
#line 1 "c:/users/katarina.perendic/downloads/audioamp2_demo/audioamp2_demo_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;
typedef enum {_tavTop, _tavMiddle, _tavBottom} TTextAlignVertical;

typedef struct Screen TScreen;

typedef struct Button_Round {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 TTextAlignVertical TextAlignVertical;
 const char *FontName;
 unsigned int Font_Color;
 char VerticalText;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton_Round;

typedef struct Image {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Picture_Name;
 char Visible;
 char Active;
 char Picture_Type;
 char Picture_Ratio;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TImage;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int Buttons_RoundCount;
 TButton_Round * const code *Buttons_Round;
 unsigned int ImagesCount;
 TImage * const code *Images;
};

extern TScreen Screen1;
extern TImage Image1;
extern TButton_Round ButtonRound1;
extern TButton_Round ButtonRound2;
extern TButton_Round ButtonRound3;
extern TButton_Round ButtonRound4;
extern TButton_Round ButtonRound5;
extern TButton_Round ButtonRound6;
extern TButton_Round * const code Screen1_Buttons_Round[6];
extern TImage * const code Screen1_Images[1];




void ButtonRound1OnClick();
void ButtonRound2OnClick();
void ButtonRound3OnClick();
void ButtonRound4OnClick();
void ButtonRound5OnClick();
void ButtonRound6OnClick();




extern char Image1_Caption[];
extern char ButtonRound1_Caption[];
extern char ButtonRound2_Caption[];
extern char ButtonRound3_Caption[];
extern char ButtonRound4_Caption[];
extern char ButtonRound5_Caption[];
extern char ButtonRound6_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawRoundButton(TButton_Round *Around_button);
void DrawImage(TImage *AImage);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "c:/users/katarina.perendic/downloads/audioamp2_demo/demo_types.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 19 "C:/Users/katarina.perendic/Downloads/AudioAmp2_demo/AudioAmp2_demo_main.c"
extern uint8_t demoFlag;
extern uint8_t demoMute;
extern uint8_t demoStandby;

void systemInit()
{
 mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_INT_PIN, _GPIO_INPUT );
 mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_AN_PIN, _GPIO_OUTPUT );
 mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_RST_PIN, _GPIO_OUTPUT );
 mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_CS_PIN, _GPIO_OUTPUT );
 mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_PWM_PIN, _GPIO_OUTPUT );
 mikrobus_logInit( _MIKROBUS2, 9600 );
 mikrobus_logWrite( "Initializing...", _LOG_LINE );
 Delay_ms( 100 );
}

void applicationInit()
{
 audioamp2_gpioDriverInit( ( const uint8_t* )&_MIKROBUS1_GPIO );
 audioamp2_setGain( _AUDIOAMP2_20DB_GAIN );
 audioamp2_setMode( _AUDIOAMP2_PLAY_MODE );
 demoFlag = 0;
 demoMute = 2;
 demoStandby = 0;
 mikrobus_logWrite( "AudioAmp 2 is initialized", _LOG_LINE );
 Delay_ms( 200 );
}

void applicationTask()
{

 if(demoMute == 1)
 {
 audioamp2_setMode( _AUDIOAMP2_MUTE_MODE );
 }
 else if(demoMute == 2)
 {
 audioamp2_setMode( _AUDIOAMP2_PLAY_MODE );
 }

 if(demoFlag == 1)
 {
 demoStandby = 0;
 audioamp2_setGain( _AUDIOAMP2_20DB_GAIN );
 audioamp2_setMode( _AUDIOAMP2_PLAY_MODE );
 demoFlag = 0;
 }
 else if(demoFlag == 2)
 {
 demoStandby = 0;
 audioamp2_setGain( _AUDIOAMP2_26DB_GAIN );
 audioamp2_setMode( _AUDIOAMP2_PLAY_MODE );
 demoFlag = 0;
 }
 else if(demoFlag == 3)
 {
 demoStandby = 0;
 audioamp2_setGain( _AUDIOAMP2_30DB_GAIN );
 audioamp2_setMode( _AUDIOAMP2_PLAY_MODE );
 demoFlag = 0;
 }
 else if (demoFlag == 4)
 {
 demoStandby = 0;
 audioamp2_setGain( _AUDIOAMP2_32DB_GAIN );
 audioamp2_setMode( _AUDIOAMP2_PLAY_MODE );
 demoFlag = 0;
 }

 if(demoStandby == 1)
 {
 audioamp2_setMode( _AUDIOAMP2_STANDBY_MODE );
 }

}

void main()
{
 Start_TP();
 systemInit();
 applicationInit();

 while (1)
 {
 Check_TP();
 applicationTask();
 }
}
